from flask import Flask
from flask import request
from flask import jsonify

application = Flask ( __name__ )

@application.route ( "/", methods = ["GET"] )
def hello_world ( ):
    return "<h1>Hello world!</h1>"

class Employee:
    def __init__ ( self, first_name, last_name, email, gender, language, position ):
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.gender = gender
        self.language = language
        self.position = position

    def __repr__ ( self ):
        return f"<Employee {self.first_name}, {self.last_name}, {self.email}, {self.gender}, {self.language}, {self.position}>"

employees = [ ]

@application.route ( "/add", methods = ["POST"] )
def add ( ):
    new_employee = Employee (
        first_name = request.json["first_name"],
        last_name = request.json["last_name"],
        email = request.json["email"],
        gender = request.json["gender"],
        language = request.json["language"],
        position = request.json["position"]
    )

    employees.append ( new_employee )

    return jsonify ( employees = [str ( employee ) for employee in employees] )

@application.route ( "/upload", methods = ["POST"] )
def upload ( ):
    content = request.files["file"].stream.read ( ).decode ( )

    for line in content.split ( "\n" ):
        new_employee = Employee ( *line.split ( "," ) )
        employees.append ( new_employee )

    return jsonify ( employees = [str ( employee ) for employee in employees] )

@application.route ( "/search", methods = ["GET"] )
def search ( ):
    result = employees
    criteria = ["first_name", "last_name", "email", "gender", "language", "position"]

    for criterium in criteria:
        if ( criterium in request.args ):
            result = [
                employee 
                for employee in result 
                if ( request.args[criterium] in getattr ( employee, criterium ) )
            ]

    return jsonify ( employees = [str ( employee ) for employee in result] )

if ( __name__ == "__main__" ):
    application.run ( debug = True )